//
//  ZCScrollMenu.m
//  ButtonList
//
//  Created by comsenz on 13-4-28.
//  Copyright (c) 2013年 ZhuChao. All rights reserved.
//

#import "ZCScrollMenu.h"


@interface ZCScrollMenu()
@property(nonatomic ,assign) UIButton *selectedBtn;

- (void)commonInit;

@end

@implementation ZCScrollMenu

- (void)dealloc
{
    self.items = nil;
    
    [super dealloc];
}

- (void)commonInit {
    self.showsHorizontalScrollIndicator = NO;
    [self setBackgroundColor:[UIColor darkGrayColor]];
    _topMarign = 15.0f;
    _spaceBetweenItem = 10.0f;
    
}

- (void)setItems:(NSArray *)items
{
    if (_items == items) {
        return;
    }
    [_items release];
    _items = [items retain];
    CGFloat orignX = 0.0f;
    int index = 0;
    for (NSString *item in items) {
        UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
        [btn setContentEdgeInsets:UIEdgeInsetsMake(_topMarign, _spaceBetweenItem/2.0f, 0.0f, _spaceBetweenItem/2.0f)];
        [btn setFrame:CGRectMake(orignX, 0.0f, 0.0f, self.bounds.size.width)];
        [btn setTitleColor:[UIColor redColor] forState:UIControlStateSelected];
        [btn setTitleColor:[UIColor redColor] forState:UIControlStateHighlighted];
        [btn setTitle:item forState:UIControlStateNormal];
        [btn sizeToFit];
        [btn addTarget:self action:@selector(itemSelected:) forControlEvents:UIControlEventTouchUpInside];
        orignX += btn.bounds.size.width;
        [self addSubview:btn];
        if (index == 0) {
            _selectedBtn = btn;
            btn.selected = YES;
        }
        [btn setTag:index++];
    }
    [self setContentSize:CGSizeMake(orignX, self.bounds.size.height)];
    
}

- (void)itemSelected:(UIButton *)sender
{
    if (sender != _selectedBtn) {
        _selectedBtn.selected = NO;
        sender.selected = YES;
        _selectedBtn = sender;
        
        [self scrollRectToVisible:[sender convertRect:sender.bounds toView:self] animated:YES];
        
        if (self.myDelegate && [self.myDelegate respondsToSelector:@selector(ZCScrollMenu:itemTouchedWithIndex:)]) {
            [self.myDelegate ZCScrollMenu:self itemTouchedWithIndex:sender.tag];
        }
        
    }
}


- (void)setSelectedItem:(NSInteger)selectedItem
{
    UIButton *btn  =(UIButton *)[self viewWithTag:selectedItem];
    [self scrollRectToVisible:[btn convertRect:btn.bounds toView:self] animated:YES];
    _selectedBtn.selected = NO;
    [btn setSelected:YES];
    _selectedBtn = btn;
    
}


- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self commonInit];
    }
    return self;
}


@end
